<?php
namespace PublishPress\Capabilities;

/*
 * PublishPress Capabilities Pro
 *
 * Handle ajax requests related to the license key
 * 
 */

require_once(PUBLISHPRESS_CAPS_ABSPATH . '/includes-pro/pro-maint.php');

if (empty($_GET['publishpress_caps_ajax_settings'])) {
    exit;
}

$key = (isset($_GET['key'])) ? sanitize_key($_GET['key']) : '';
switch ($_GET['publishpress_caps_ajax_settings']) {
    case 'activate_key':
        check_admin_referer('wp_ajax_pp_activate_key');
        if (
            is_multisite() && !is_super_admin() && (Maint::isNetworkActivated() || Maint::isMuPlugin())
        ) {
            return;
        }

        // Bypass license activation
        $setting = ['license_status' => 'valid', 'license_key' => sanitize_key($key), 'expire_date' => 'lifetime'];
        update_option('cme_edd_key', $setting);

        $response = json_encode((object)['license' => 'valid', 'expires' => 'lifetime']);
        echo $response;
        exit();

        break;

    case 'deactivate_key':
        check_admin_referer('wp_ajax_pp_deactivate_key');
        if (
            is_multisite() && !is_super_admin() && (Maint::isNetworkActivated() || Maint::isMuPlugin())
        ) {
            return;
        }

        // Bypass license deactivation
        delete_option('cme_edd_key');
        $response = json_encode((object)['license' => 'deactivated']);
        echo $response;
        exit();

        break;
}
